# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`auks`](#auks): Installs and configures AUKS.

### Defined types

* [`auks::build`](#auksbuild): Builds the RPM files to install AUKS.

## Classes

### <a name="auks"></a>`auks`

Installs and configures AUKS.

#### Parameters

The following parameters are available in the `auks` class:

* [`dependencies`](#dependencies)
* [`repository_url`](#repository_url)
* [`repository_revision`](#repository_revision)
* [`primary_server`](#primary_server)
* [`common`](#common)
* [`api`](#api)
* [`auksd`](#auksd)
* [`renewer`](#renewer)
* [`rules`](#rules)
* [`secondary_server`](#secondary_server)
* [`patch_slurm_dependency`](#patch_slurm_dependency)
* [`source_directory`](#source_directory)
* [`config_file`](#config_file)

##### <a name="dependencies"></a>`dependencies`

Data type: `Array[String]`

A list of packages that need to be installed to build
the AUKS RPMs.

##### <a name="repository_url"></a>`repository_url`

Data type: `String`

The URL of the Git repository to get the sources from.

##### <a name="repository_revision"></a>`repository_revision`

Data type: `String`

The revision to retrieve from Git.

##### <a name="primary_server"></a>`primary_server`

Data type: `Hash`

The configuration of the primary AUKS server. The
name, port and principal properties need to be provided
for this server.

##### <a name="common"></a>`common`

Data type: `Hash`

The attributes to be configured in the common section of the
auks.conf configuration file.

##### <a name="api"></a>`api`

Data type: `Hash`

The attributes to be configured in the api section of the
auks.conf configuration file.

##### <a name="auksd"></a>`auksd`

Data type: `Hash`

The attributes to be configured in the auksd section of the
auks.conf configuration file.

##### <a name="renewer"></a>`renewer`

Data type: `Hash`

The attributes to be configured in the renewer section of the
auks.conf configuration file.

##### <a name="rules"></a>`rules`

Data type: `Array[Hash]`

The user-defined access rules. Each of the rules must specify
the principal, the host and the role.

##### <a name="secondary_server"></a>`secondary_server`

Data type: `Optional[Hash]`

The configuration of an optional secondary AUKS
server. If specified, the same properties as for
the primary server must be specified.

Default value: ``undef``

##### <a name="patch_slurm_dependency"></a>`patch_slurm_dependency`

Data type: `Boolean`

Patch out the dependency on Slurm packages from
the RPM. This is required if Slurm has been
built from source on the target machine. This
parameter defaults to false.

Default value: ``false``

##### <a name="source_directory"></a>`source_directory`

Data type: `String`

The directory where the sources of AUKS should be
stored. This parameter defaults to '/usr/local/src'.

Default value: `'/usr/local/src'`

##### <a name="config_file"></a>`config_file`

Data type: `String`

The path to the AUKS configuration file. This parameter
defaults to '/etc/auks/auks.conf'.

Default value: `'/etc/auks/auks.conf'`

## Defined types

### <a name="auksbuild"></a>`auks::build`

Builds the RPM files to install AUKS.

#### Parameters

The following parameters are available in the `auks::build` defined type:

* [`src_dir`](#src_dir)
* [`patch_slurm_dependency`](#patch_slurm_dependency)

##### <a name="src_dir"></a>`src_dir`

Data type: `String`

The directory where the source has been placed into. The
resulting RPM files will be placed in this directory, too.

##### <a name="patch_slurm_dependency"></a>`patch_slurm_dependency`

Data type: `Boolean`

If true, the build process will patch the spec
file created by the configure step to exclude
the Slurm runtime and build dependencies in the
RPM. This is required if Slurm has been built
from source instead of installing it from a
package repository.

